<template>
  <div class="sim-container">
    <h2 class="title">
      Simulate RUNE Deterministic Value
    </h2>
    <pre class="text-content">
      RUNE’s value can be simulated by predicting market outcomes and the total value locked in the network.

      It's driven from <span class="formula">(3 * Non-RUNE TVL) / RUNE Circulating Value</span>
    </pre>
    <div class="simulator">
      <table-content
        :settings='{cols: ["Current Value", runePrice]}'
      >
      </table-content>
      <small-divider></small-divider>
      <table-content
        :settings='{cols: ["Deterministic Value", determiniaticVal]}'
      >
      </table-content>
      <small-divider></small-divider>
      <div class="simulate-table" v-if="coins && coins.length > 0">
        <div class="coin-item" v-for="(c, i) in coins" :key="i">
          <div class="table-row">#{{i+1}}</div>
          <div class="table-row">If</div>
          <div class="table-row input">
            {{c.name}}
            <select v-model="c.selected" :disabled="c.disabled" @change="changeCoin(i)">
              <option 
                v-for="option in options" 
                :key="option.value"
                :value="option.value"
              >
                {{option.text}}
              </option>
            </select>
          </div>
          <div class="table-row">price will change by</div>
          <div class="table-row input">
            <client-only>
              <input placeholder="1" :value="c.multiply" @focus="deleteChars($event, 'multiply', i)" @blur="handleMInput($event, i)">
            </client-only>
          </div>
          <div class="table-row">and</div>
          <div class="table-row input">
            <input placeholder="1" :value="c.locked" @focus="deleteChars($event, 'locked', i)" @blur="handlePInput($event, i)">
          </div>
          <div class="table-row">will be locked into the network</div>
          <div class="remove-coin" @click="removeCoin(i)">
            <CrossIcon class="remove-icon" />
          </div>
        </div>
      </div>
      <small-divider></small-divider>
      <orgButton
        :settings="{
          mode: 'full',
          clickEvent: 'addCoin',
          buttons: [{
            text: 'Add Coin',
          }]
        }"      
        @addCoin="addCoin"
      >
      </orgButton>
    </div>
  </div>
</template>

<script>
import CrossIcon from "~/assets/images/icons/cross-circle.svg?inline";

export default {
  components: {
    CrossIcon
  },
  props: [
    'settings'
  ],
  data() {
    return {
      coins: [
        {
          selected: "bitcoin",
          thorPool: "BTC.BTC",
          multiply: "1X",
          locked: "1%",
          disabled: true
        },
        {
          selected: "ethereum",
          thorPool: "ETH.ETH",
          multiply: "1X",
          locked: "1%",
          disabled: true
        }
      ],
      options: [
        { value: 'binancecoin', text: 'BNB', thorPool: 'BNB.BNB' },
        { value: 'ethereum', text: 'ETH', thorPool: 'ETH.ETH' },
        { value: 'avalanche-2', text: 'AVAX', thorPool: 'AVAX.AVAX' },
        { value: 'cosmos', text: 'ATOM', thorPool: 'GAIA.ATOM' },
        { value: 'dogecoin', text: 'DOGE', thorPool: 'DOGE.DOGE' },
        { value: 'litecoin', text: 'LTC', thorPool: 'LTC.LTC' },
        { value: 'bitcoin-cash', text: 'BCH', thorPool: 'BCH.BCH' },
        { value: 'bitcoin', text: 'BTC', thorPool: 'BTC.BTC' },
        { value: 'binance-usd', text: 'BUSD', thorPool: 'BNB.BUSD-BD1' },
        { value: 'usd-coin', text: 'USDC', thorPool: 'ETH.USDC-0XA0B86991C6218B36C1D19D4A2E9EB0CE3606EB48' },
        { value: 'tether', text: 'USDT', thorPool: 'ETH.USDT-0XDAC17F958D2EE523A2206206994597C13D831EC7' },
      ]
    }
  },
  computed: {
    determiniaticVal: function() {
      if (this.settings && this.settings.AllMarkets) {
        let nonRUNETVL = 0;
        let rune = this.settings.AllMarkets.find(e => e.id === 'thorchain');
        for (let coinIndex in this.coins) {
          let market = this.settings.AllMarkets.find(e => e.id === this.coins[coinIndex].selected);
          if (!market)
            continue
          let coin = this.coins[coinIndex];
          nonRUNETVL += (market.circulating_supply * (Number.parseFloat(coin.locked)/100)) * (market.current_price * Number.parseFloat(coin.multiply));
        }
        return '$' + ((((nonRUNETVL + (Number.parseFloat(this.sharedTVL) ?? 0)) * 3) / rune.circulating_supply)).toFixed(2);
      }
      return 'Fetching Data'
    },
    runePrice: function() {
      if (this.settings && this.settings.AllMarkets) {
        return ('$' + this.settings.AllMarkets?.find(e => e.id === 'thorchain')?.current_price);
      }
      return 'Fetching Data';
    },
    sharedTVL: function() {
      if (this.settings.pools) {
        let res = 0;
        let extraAssets = this.settings.pools.filter(p => !this.coins.map(m => m.thorPool).includes(p.asset.toUpperCase()))
        for (let pool of extraAssets) {
          res += Number.parseFloat(pool.assetPriceUSD) * (Number.parseFloat(pool.assetDepth)/10**8)
        }
        return res.toFixed(4);
      }
      return 0;
    }
  },
  mounted() {
    for (let coin in this.coins) {
      this.baseLocked(coin)
    }
  },
  methods: {
    multiplier(num) {
      num = num.replace(/[^0-9.]+/g, '')
      return num.replace(/^[-+]?(([0-9]*[\.])?[0-9]+)/g, '$1X')
    },
    handleMInput(event, index) {
      this.coins[index].multiply = this.multiplier(event.target.value)
    },
    percenter(num) {
      num = num.replace(/[^0-9.]+/g, '')
      return num.replace(/^[-+]?(([0-9]*[\.])?[0-9]+)/g, '$1%')
    },
    handlePInput(event, index) {
      this.coins[index].locked = this.percenter(event.target.value)
    },
    deleteChars(event, key, index) {
      this.coins[index][key] = event.target.value.replace(/\%|\X/g, '')
    },
    addCoin() {
      this.coins.push({
        selected: 'binancecoin',
        thorPool: 'BNB.BNB',
        multiply: '1X',
        locked: '1%',
        disabled: false
      })
      this.baseLocked(this.coins.length-1);
    },
    changeCoin(index) {
      let thorPool = this.options.find(e => e.value === this.coins[index].selected)?.thorPool;
      this.coins[index].thorPool = thorPool;
      this.baseLocked(index);
    },
    baseLocked(index) {
      if (this.coins && this.settings && this.settings.pools) {
        let thorPool = this.settings.pools.find(e => e.asset === this.coins[index].thorPool);
        let market = this.settings.AllMarkets.find(e => e.id === this.coins[index].selected);
        let assetDepth = Number.parseFloat(thorPool?.assetDepth ?? 0) / 10**8;
        if (assetDepth == 0)
          this.coins[index].locked = '1%' 
        else
          this.coins[index].locked = market?.circulating_supply ? (((assetDepth / market?.circulating_supply) * 100).toFixed(4) + '%') : '1%'
      }
    },
    removeCoin(index) {
      this.coins.splice(index, 1)
    }
  }
}
</script>

<style lang="scss" scoped>
.sim-container {
  border-radius: 1.5rem;
  width: 100%;
  background: #000b12;
  display: flex;
  flex-direction: column;
  padding: 2.5rem;

  .title {
    font-family: "Roboto";
    font-size: 2.125rem;
    line-height: 2.5rem;
    color: #fff;
    margin-bottom: 1.1875rem;
    margin-top: -0.35rem;
  }

  .text-content {
    margin: 0;
    word-break: break-word;
    white-space: pre-line;
    font-family: 'Roboto';
    font-size: 1.5rem;
    font-weight: 500;
    color: #4E5C66;
  }

  .formula {
    font-size: 1.2rem;
    padding: .4rem;
    color: #d1d5da;
    background-color: #000305;
    border-radius: .3rem;
  }

  .simulator {
    margin-top: 2rem;

    .simulate-table {
      display: flex;
      flex-direction: column;
      border: 2px solid #15252E;
      border-radius: 0.5rem;

      .coin-item {
        display: flex;
        font-weight: 700;
        padding: 0 1rem;
        width: 100%;
        min-height: 3.375rem;
        align-items: center;
        border-bottom: 2px solid #15252E;

        &:last-of-type {
          border: none;
        }

        .table-row {
          margin: 1rem;
          color: #d1d5da;

          &.input {
            color: $thor-blue-color;
            width: 4.5rem;
            text-align: center;

            select {
              // A reset of styles, including removing the default dropdown arrow
              appearance: none;
              grid-template-areas: "select";
              align-items: center;
              cursor: pointer;
              color: $thor-blue-color;
              text-align: center;
              background-color: #15252E;
              height: 1.5rem;
              border-radius: .2rem;
              padding: 0 .3rem;
              border: none;
              outline: none;
              width: 100%;

              &, &::after {
                grid-area: select;
              }

              &::-ms-expand {
                display: none;
              }

              &:focus {
                outline: none;
              }

              &::after {
                display: block;
                content: "";
                width: 0.8rem;
                height: 0.5rem;
                background-color: $thor-blue-color;
                clip-path: polygon(100% 0%, 0 0%, 50% 100%);
                justify-self: end;
              }
            }
            
            input {
              border-bottom: 2px solid $thor-blue-color;
              border: none;
              padding: 0 6px;
              border-radius: .2rem;
              background-color: #15252E;
              color: #d1d5da;
              width: 5rem;
              height: 1.5rem;
              font-weight: 700;
              text-overflow: ellipsis;


              &:focus {
                outline: none;
              }

              /* Chrome, Safari, Edge, Opera */
              &::-webkit-outer-spin-button,
              &::-webkit-inner-spin-button {
                -webkit-appearance: none;
                margin: 0;
              }

              /* Firefox */
              &[type=number] {
                -moz-appearance: textfield;
              }
            }

          }
        }


        .remove-coin {
          cursor: pointer;
          margin-left: auto;
        }

        .remove-icon {
          width: 1.2rem;
          height: 1.2rem;
          fill: $thor-blue-color;
        }
      }
    }
  }
}
</style>